function calc_top_menu_items(isStart) {
    var buttonWidth = 65;
    var menuContainer = document.getElementById('next-menu-container');
    menuContainer.style.display = "none";
    var container = document.getElementById('top-menu-ul');
    var containerWidth = Math.ceil(0.96 * parseInt(container.offsetWidth)) - buttonWidth;
    var startItems = document.getElementsByClassName('top-menu-item');
    var items = [];
    for (i = 0; i < startItems.length; i++) {
        var find = false;
        if (startItems[i].parentNode.className == 'float-menu-container')
            continue;
        for (var j = 0; j < startItems[i].attributes.length; j++)
            if ((startItems[i].attributes[j].name == "name") && (startItems[i].attributes[j].value == "button-container")) {
                find = true;
                break;
            }
        if (find) continue;
        items.push(startItems[i]);
    }
    var itemLength = items.length; // из-за кнопки
    var widthSum = 0;
    var i;
    var button;
    var lastIndex = 0;
    var minWidthes = [];
    for (i = 0; i < itemLength; i++) {
        var curWidth = items[i].childNodes[0].offsetWidth;
        minWidthes[i] = curWidth;
        widthSum += curWidth;
        if (widthSum <= containerWidth)
            lastIndex++;
    }
    items[0].style.marginLeft = '20px';
    if (isStart) for (i = 0; i < itemLength; i++) minWidthes[i] += 1;
    if (lastIndex < itemLength) {// увы, все пункты не влезли. Будем смотреть, что убрать
        for (i = 0; i < lastIndex; i++)
            remove_class(items[i], 'top_menu_hidden');
        // посмотрим, какая ширина должна быть у остальных
        var maxWidth = 0;
        for (i = lastIndex; i < itemLength; i++) {
            if (minWidthes[i] > maxWidth)
                maxWidth = minWidthes[i];
        }
        // убираем остатки и делаем новый список
        var newList = '<ul class="float-menu-container">';
        for (i = lastIndex; i < itemLength; i++) {
            remove_class(items[i], 'top_menu_hidden');
            items[i].style.width = maxWidth + 'px';
            newList += toHtmlString(items[i]);
            items[i].style.width = '';
            add_class(items[i], 'top_menu_hidden');
        }
        newList += '</ul>';
        menuContainer.innerHTML = newList;
        // а кнопка там всегда была. Только скрывается
        button = document.getElementById('top_next_button');
        button.style.display = "";
    }
    else {//все пункты влезают по ширине
        for (i = 0; i < itemLength; i++) {
            items[i].style.width = minWidthes[i] + 'px';
            remove_class(items[i], 'top_menu_hidden');
        }
        button = document.getElementById('top_next_button');
        button.style.display = "none";
    }
}

function add_class(element, className) {
    if (element.classList != undefined) {
        if (!element.classList.contains(className))
            element.classList.add(className);
    }
    else if (element.className.indexOf(className) < 0)
        element.className += ' ' + className;
}

function remove_class(element, className) {
    if (element.classList != undefined) {
        if (element.classList.contains(className))
            element.classList.remove(className);
    }
    else if (element.className.indexOf(className) >= 0)
        element.className = element.className.replace(className, '');
}

function calc_bottom_menu_columns() {
    var minBlockWidth = 250;

    var container = document.getElementById('footer_menu_container');
    if (container == undefined) return '';
    var containerWidth = container.offsetWidth;
    containerWidth = (containerWidth > 1240) ? 1240 : containerWidth;
    var colCount = parseInt(containerWidth / minBlockWidth);
    var points = document.getElementsByClassName('main_point');
    var weightSum = 0;
    for (var s = 0; s < points.length; s++) {
        if (points[s].getAttribute('special') == '1') continue;
        weightSum += parseInt(points[s].getAttribute('point_weight'));
    }
    var maxWeight = weightSum / colCount;
    var totalHtml = '<ul class="footer_column">';
    var ulHtmlDivide = '</ul><ul class="footer_column">';
    var indexes = [];
    var lastWeight = 0;
    for (var i = 0; i < points.length; i++) {
        if (in_array(i, indexes)) continue;
        if (points[i].getAttribute('special') == '1') continue;
        var weight = parseInt(points[i].getAttribute('point_weight'));
        totalHtml += toHtmlString(points[i]);
        indexes.push(i);
        if (weight < maxWeight) {
            while (weight < maxWeight) {
                var min = Math.abs(weight - maxWeight);
                var minWeight = 100500;
                var index = -1;
                for (var j = 0; j < points.length; j++) {
                    if (in_array(j, indexes)) continue;
                    if (points[j].getAttribute('special') == '1') continue;
                    var curWeight = parseInt(points[j].getAttribute('point_weight'));
                    var diff = Math.abs(weight + curWeight - maxWeight);
                    if (diff < min) {
                        minWeight = curWeight;
                        min = diff;
                        index = j;
                    }
                    else if ((diff == min) && (curWeight < minWeight)) {
                        minWeight = curWeight;
                        index = j;
                    }
                }
                if (index != -1) {
                    totalHtml += toHtmlString(points[index]);
                    weight += parseInt(points[index].getAttribute('point_weight'));
                    indexes.push(index);
                }
                else break;
            }
            totalHtml += ulHtmlDivide;
        }
        else totalHtml += ulHtmlDivide;

        lastWeight = weight;
    }

    var lastHtml = '';
    var curLastWeight = 0;
    for (i = 0; i < points.length; i++) {
        if (points[i].getAttribute('special') != '1') continue;
        curLastWeight += parseInt(points[i].getAttribute('point_weight'));
        lastHtml += toHtmlString(points[i]);
    }
    if (Math.abs(lastWeight - maxWeight) > Math.abs(lastWeight + curLastWeight - maxWeight))
        totalHtml = totalHtml.substr(0, totalHtml.length - ulHtmlDivide.length) + lastHtml;
    else totalHtml += lastHtml;
    var regex = new RegExp('<ul></ul>', "gim");
    totalHtml = totalHtml.replace(regex, '');
    regex = new RegExp('<ul/>', "gim");
    totalHtml = totalHtml.replace(regex, '');
    totalHtml = totalHtml + '</ul>';
    regex = new RegExp('<ul class="footer_column"></ul>');
    totalHtml = totalHtml.replace(regex, '');
    container.innerHTML = totalHtml;
    return true;
}

function toHtmlString(element) {
    if (window.XMLSerializer) {
        var s = new XMLSerializer();
        return s.serializeToString(element);
    }
    else return element.outerHTML;
}

function in_array(element, array) {
    for (var i = 0; i < array.length; i++)
        if (array[i] == element)
            return true;
    return false;
}

function getRealStyle(element) {
    return element.currentStyle || window.getComputedStyle(element, null);
}

function init() {
    // выходим, если функция уже выполнялась
    if (arguments.callee.done) return;

    // устанавливаем флаг, чтобы функция не исполнялась дважды
    arguments.callee.done = true;

    // что-нибудь делаем
    calc_bottom_menu_columns();
    calc_top_menu_items(true);
    pass_type();// меняет тип поля ввода пароля для отображения в нем подсказаки

    //Тут еще надо навесить пару событий
    var button = document.getElementById('top_next_button');
    var menuContainer = document.getElementById('next-menu-container');
    menuContainer.style.display = "none";
    button.onclick = function (event) {
        var computedStyle = getRealStyle(menuContainer);
        menuContainer.style.display = (computedStyle.display == "none") ? "" : "none";
        if (event != undefined) event.stopPropagation();
        else window.event.cancelBubble = true;
    };
    document.onclick = function () {
        menuContainer.style.display = "none";
    };
}

/* для Mozilla/Firefox/Opera 9 */
if (document.addEventListener) {
    document.addEventListener("DOMContentLoaded", init, false);
}

/* для Internet Explorer */
if (document.getElementsByClassName == undefined) {
    document.getElementsByClassName = function (cl) {
        var retnode = [];
        var myclass = new RegExp('\\b' + cl + '\\b');
        var elem = this.getElementsByTagName('*');
        for (var i = 0; i < elem.length; i++) {
            var classes = elem[i].className;
            if (myclass.test(classes)) retnode.push(elem[i]);
        }
        return retnode;
    }
}

document.write("<script id=\"__ie_onload\" defer=\"defer\" src=\"javascript:void(0)\"><\/script>");
var script = document.getElementById("__ie_onload");
script.onreadystatechange = function () {
    if (this.readyState == "complete") {
        // "getElementsByClassName" не определен IE,
        // так что этот метод можно реализовать в JavaScript
        init(); // вызываем обработчик для onload
    }
};

/* для Safari */
if (/WebKit/i.test(navigator.userAgent)) { // условие для Safari
    var _timer = setInterval(function () {
        if (/loaded|complete/.test(document.readyState)) {
            clearInterval(_timer);
            init(); // вызываем обработчик для onload
        }
    }, 10);
}

/* для остальных браузеров */
window.onload = init;

/* назначим пересчет при изменении размеров */
window.onresize = Resize;

function Resize(event) {
    // выходим, если не было инициализации
    if (arguments.callee.done) return;
    var menuContainer = document.getElementById('next-menu-container');
    menuContainer.style.display = "none";
    calc_bottom_menu_columns();
    calc_top_menu_items(false);
    if (event != undefined)
        event.stopPropagation();
    else window.event.cancelBubble = true;
}

function pass_type() {
    var tmp = navigator.userAgent.toLowerCase();
    if ((tmp.indexOf('msie 7') == -1) && (tmp.indexOf('msie 8') == -1)) {
        var pass_input = document.getElementById('USER_PASSWORD');
        if (pass_input != null) {
            pass_input.setAttribute('type', 'text');
        }
    }

}